<template>
  <!-- style="text-transform: none !important;" -->
  <v-btn 
    :color="color" 
    :disabled="disabled" 
    :round="round"
    :flat="flat"
    :icon="icon"
    class="jbtn-file"
  >
    <slot/>
    <input 
      v-if="uploadReady" 
      :accept="accept" 
      :multiple="multiple" 
      type="file" 
      @change="fileSelected">
  </v-btn>
</template>

<script>

import {bus} from '@js/bus'

export default {

	name: 'UploadButton',
    
	props: {
		selectedCallback: Function,
		color: {
			type: String,
			default: 'primary'
		},
		disabled: {
			type: Boolean,
			default: false
		},
		accept: {
			type: String,
			default: ''
		},
		multiple: {
			type: Boolean,
			default: false
		},
		round: {
			type: Boolean,
			default: false
		},
		flat: {
			type: Boolean,
			default: false
		},
		icon: {
			type: Boolean,
			default: false
		}
	},

	data() {
		return {
			uploadReady: true
		}
	},

	created() {
		bus.$on('clear-upload-button', this.clear)
	},

	beforeDestroy() {
		bus.$off('clear-upload-button', this.clear)
	},

	methods: {
		fileSelected(e) {
			if (this.selectedCallback) {

				if(e.target.files) {
					if(!this.multiple)
						this.selectedCallback(e.target.files[0])
					else
						this.selectedCallback(e.target.files)
				} else {
					this.selectedCallback(null)
				}

				//if(!multiple && )

				/*if (e.target.files[0]) {
            this.selectedCallback(e.target.files[0]);
          } else {
            this.selectedCallback(null);
          }*/

			}
		},

		clear () {
			this.uploadReady = false
			this.$nextTick(() => {
				this.uploadReady = true
			})
		},



	}
}
</script>

<style scoped>
  .jbtn-file {
    cursor: pointer;
    position: relative;
    overflow: hidden;
  }
  .jbtn-file input[type=file] {
    position: absolute;
    top: 0;
    right: 0;
    min-width: 100%;
    min-height: 100%;
    text-align: right;
    filter: alpha(opacity=0);
    opacity: 0;
    outline: none;
    cursor: inherit;
    display: block;
  }
</style>